#include "pgm.h"

/* reads in two pgm files and displays the result of subtracting the 
/* second from the first in pgm format with a comment denoting the 
/* input images*/

void subtract(unsigned char *im1, unsigned char *im2, unsigned char *result,
	int size, char *comment);

main(int argc, char* argv[])
{
  unsigned char *image1, *image2, *result;
  int width1, height1, size1, max1;
  int width2, height2, size2, max2;
  char base[20], fname[35], comment[80];

  if (argc!=3)
  {
    printf("\nExecutable: x_subtract images\n");
    printf("Input: two pgm images of equal dimension\n");
    printf("Output: pgm file (sub.pgm) representing the subtraction of ");
    printf("the second image from the first\n");
    exit(0);
  }

  max1=read_pgm(argv[1], &image1, &width1, &height1);
  size1=width1*height1;
  max2=read_pgm(argv[2], &image2, &width2, &height2);
  size2=width2*height2;

  if ((width1==width2)&&(height1==height2)&&(max1==max2))
  {
    result = (unsigned char *) calloc(size1, 1);
    subtract(image1, image2, result, size1, comment);
    sprintf(comment, "%s - %s", argv[1], argv[2]);
    write_pgm("sub.pgm", result, width1, height1, max1, comment);
  }
  else 
  {
    printf("Cannot subtract images\n");
    printf("image: \t%s\t%s\n", argv[1], argv[2]);
    printf("width: \t%d\t%d\n", width1, width2);
    printf("height:\t%d\t%d\n", height1, height2);
    printf("max:   \t%d\t%d\n", max1, max2);
  }

  free(image1);
  free(image2);
  free(result);

}

void subtract(unsigned char *im1, unsigned char *im2, unsigned char *result,
	int size, char *comment)
{
  int i, count=0;
  int temp;

  for (i=0; i<size; i++)
  {
    temp=im1[i]-im2[i];
    if (temp<0) 
      result[i]=0;
    else result[i]=temp;
    if (result[i]) count++;
  }

  sprintf(comment, "Number of differing pixels = %d", count);
}
